export enum DB_FORMAT {
    //#region  account.ts
    FORMAT_CREATE = "{\
    Type:byte,\
    Currency:uint,\
    PubKey:arr33,\
    Name:str40,\
    Adviser:uint,\
    Smart:uint32,\
    Reserve:arr3,\
    }",
    FORMAT_MONEY_TRANSFER = '{\
    Type:byte,\
    Currency:uint,\
    FromID:uint,\
    To:[{ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    Sign:arr64,\
    }',
    FORMAT_MONEY_TRANSFER_BODY = '{\
    Type:byte,\
    Currency:uint,\
    FromID:uint,\
    To:[{ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    }',
    FORMAT_MONEY_TRANSFER2 = "{\
    Type:byte,\
    Version:byte,\
    Currency:uint,\
    FromID:uint,\
    To:[{ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    Sign:arr64,\
    }",
    FORMAT_MONEY_TRANSFER_BODY2 = "{\
    Type:byte,\
    Version:byte,\
    Currency:uint,\
    FromID:uint,\
    To:[{ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    }",
    FORMAT_MONEY_TRANSFER3 = "{\
    Type:byte,\
    Version:byte,\
    Reserve:uint,\
    FromID:uint,\
    To:[{PubKey:tr,ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    Body:tr,\
    Sign:arr64,\
    }",
    FORMAT_MONEY_TRANSFER_BODY3 = "{\
    Type:byte,\
    Version:byte,\
    Reserve:uint,\
    FromID:uint,\
    To:[{PubKey:tr,ID:uint,SumCOIN:uint,SumCENT:uint32}],\
    Description:str,\
    OperationID:uint,\
    Body:tr,\
    }",
    FORMAT_ACCOUNT_HASH = "{\
    Type:byte,\
    BlockNum:uint,\
    AccHash:buffer32,\
    }",
    FORMAT_ACCOUNT_HASH3 = "{\
    Type:byte,\
    BlockNum:uint,\
    AccHash:buffer32,\
    AccountMax:uint,\
    SmartHash:buffer32,\
    SmartCount:uint,\
    }",
    //#endregion

    //#region file.ts
    FORMAT_FILE_CREATE = "{\
    type:byte,\
    Name:str,\
    ContentType:str,\
    Reserve:arr10,\
    Data:tr\
    }",
    //#endregion

    //#region smart.ts
    FORMAT_SMART_CREATE = "{\
    Type:byte,\
    TokenGenerate:byte,\
    StartValue:uint,\
    OwnerPubKey:byte,\
    ISIN:str,\
    Zip:byte,\
    AccountLength:byte,\
    StateFormat:str,\
    Category1:byte,\
    Category2:byte,\
    Category3:byte,\
    Reserve:arr20,\
    IconBlockNum:uint,\
    IconTrNum:uint16,\
    ShortName:str5,\
    Name:str,\
    Description:str,\
    Code:str,\
    HTML:str,\
    }",
    FORMAT_SMART_RUN = "{\
    Type:byte,\
    Account:uint,\
    MethodName:str,\
    Params:str,\
    FromNum:uint,\
    OperationID:uint,\
    Reserve:arr10,\
    Sign:arr64,\
    }",
    FORMAT_SMART_CHANGE = "{\
    Type:byte,\
    Account:uint,\
    Smart:uint32,\
    Reserve:arr10,\
    FromNum:uint,\
    OperationID:uint,\
    Sign:arr64,\
    }",
    // global.DApps.Smart.FORMAT_ROW
    FORMAT_SMART_ROW = "{\
    Version:byte,\
    TokenGenerate:byte,\
    ISIN:str12,\
    Zip:byte,\
    BlockNum:uint,\
    TrNum:uint16,\
    IconBlockNum:uint,\
    IconTrNum:uint16,\
    ShortName:str5,\
    Name:str40,\
    Account:uint,\
    AccountLength:byte,\
    Category1:byte,\
    Category2:byte,\
    Category3:byte,\
    Owner:uint,\
    Reserve:arr20,\
    StateFormat:str,\
    Description:str,\
    Code:str,\
    HTML:str,\
    SumHash:hash,\
    }",
    //#endregion

    //#region block-loader-const.ts
    FORMAT_BLOCK_TRANSFER = "{\
    BlockNum:uint,\
    TreeHash:hash,\
    arrContent:[tr],\
    }",
    FORMAT_REST_TRANSFER = "{\
    Result:uint,\
    Version:uint,\
    Arr:[arr200],\
    ProofHash:hash,\
    ProofArrL:<hash>,\
    ProofArrR:<hash>,\
    }",
    FORMAT_SMART_TRANSFER = "{\
    Result:uint,\
    Arr:[tr],\
    }"
    //#endregion
}
