/*
 * @project: TERA
 * @version: Development (beta)
 * @license: MIT (not for evil)
 * @copyright: Yuriy Ivanov (Vtools) 2017-2019 [progr76@gmail.com]
 * Web: https://terafoundation.org
 * Twitter: https://twitter.com/terafoundation
 * Telegram:  https://t.me/terafoundation
*/

"use strict";
let WorkStructRun = {};
import DApp from './dapp'
import { TYPE_TRANSACTION } from '../constant/account';
import { DB_FORMAT } from '../constant/db-format';
export default class FileApp extends DApp {
    constructor() {
        super()
    }
    OnWriteTransaction(Block, Body, BlockNum, TrNum, ContextFrom) {
        return true;
    }
    GetObjectTransaction(Body) {
        var TR = global.BufLib.GetObjectFromBuffer(Body, DB_FORMAT.FORMAT_FILE_CREATE, WorkStructRun);
        return TR;
    }
    GetScriptTransaction(Body) {
        var TR = this.GetObjectTransaction(Body);
        global.ConvertBufferToStr(TR)
        return JSON.stringify(TR, undefined, 2);
    }
    GetVerifyTransaction(Block, BlockNum, TrNum, Body) {
        return 1;
    }
};
var App = new FileApp;
global.DApps.File = App;
global.DAppByType[TYPE_TRANSACTION.TYPE_TRANSACTION_FILE] = App;
